# Copyright (C) 2023 - 2024 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

from typing import List, Optional, Union

from ansys.rocky.core._api_stubs.rocky30.plugins.api.ra_grid_process_element import (
    RAGridProcessElementItem as RAGridProcessElementItem,
)

class RAAirFlow(RAGridProcessElementItem):
    @classmethod
    def GetWrappedClass(self): ...
    @classmethod
    def GetClassName(self) -> str: ...
    def SetPartIdIfValid(self) -> None: ...
    def GetAirDensity(self, unit: Optional[str] = ...) -> float: ...
    def SetAirDensity(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetAirKinematicViscosity(self, unit: Optional[str] = ...) -> float: ...
    def SetAirKinematicViscosity(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetBoundaryConditionType(self) -> str: ...
    def SetBoundaryConditionType(self, value: str) -> None: ...
    def GetValidBoundaryConditionTypeValues(self) -> List[str]: ...
    def GetCellSize(self, unit: Optional[str] = ...) -> float: ...
    def SetCellSize(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetInteractionScale(self, unit: Optional[str] = ...) -> float: ...
    def SetInteractionScale(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetMaxX(self, unit: Optional[str] = ...) -> float: ...
    def SetMaxX(self, value: Union[str, float], unit: Optional[str] = ...) -> None: ...
    def GetMaxY(self, unit: Optional[str] = ...) -> float: ...
    def SetMaxY(self, value: Union[str, float], unit: Optional[str] = ...) -> None: ...
    def GetMaxZ(self, unit: Optional[str] = ...) -> float: ...
    def SetMaxZ(self, value: Union[str, float], unit: Optional[str] = ...) -> None: ...
    def GetMinX(self, unit: Optional[str] = ...) -> float: ...
    def SetMinX(self, value: Union[str, float], unit: Optional[str] = ...) -> None: ...
    def GetMinY(self, unit: Optional[str] = ...) -> float: ...
    def SetMinY(self, value: Union[str, float], unit: Optional[str] = ...) -> None: ...
    def GetMinZ(self, unit: Optional[str] = ...) -> float: ...
    def SetMinZ(self, value: Union[str, float], unit: Optional[str] = ...) -> None: ...
    def GetSpeedOfSound(self, unit: Optional[str] = ...) -> float: ...
    def SetSpeedOfSound(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetStartWhenParticlesEnter(self) -> bool: ...
    def SetStartWhenParticlesEnter(self, value: bool) -> None: ...
    def GetStartTime(self, unit: Optional[str] = ...) -> float: ...
    def SetStartTime(
        self, value: Union[str, float], unit: Optional[str] = ...
    ) -> None: ...
    def GetUseAirflow(self) -> bool: ...
    def SetUseAirflow(self, value: bool) -> None: ...
